<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备品牌" prop="deviceId">
        <el-select v-model="queryParams.deviceId" clearable filterable remote reserve-keyword placeholder="请输入设备品牌"
          :remote-method="remoteMethod" :loading="loading" style="width: 400px;">
          <el-option v-for="device in deviceList" :key="device.deviceId"
            :label="device.name + '-' + device.series + '-' + device.code" :value="device.deviceId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="负责人" prop="userId">
        <el-select v-model="queryParams.userId" filterable clearable @change="handleQuery">
          <el-option v-for="item in $store.state.user.userList" :key="item.userId" :label="item.nickName"
            :value="item.userId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="发生日期" prop="occurDate">
        <el-date-picker clearable v-model="queryParams.occurDate" type="date" value-format="yyyy-MM-dd"
          placeholder="请选择发生日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['device:record:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['device:record:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['device:record:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['device:record:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="deviceExpenseList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="设备类型" align="center" prop="device.name" />
      <el-table-column label="设备品牌" align="center" prop="device.brand" />
      <el-table-column label="规格型号" align="center" prop="device.series" />
      <el-table-column label="出厂编号" align="center" prop="device.code" />
      <el-table-column label="负责人" align="center" prop="userId">
        <template slot-scope="scope">
          {{ getUserName(scope.row.userId) }}
        </template>
      </el-table-column>
      <el-table-column label="费用类型" align="center" prop="expenseType">
        <template slot-scope="scope">
          <el-tag :type="expenseTypeStyle(scope.row.expenseType)">{{ expenseTypeText(scope.row.expenseType)
            }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="费用金额" align="center" prop="expense" />
      <el-table-column label="发生日期" align="center" prop="occurDate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.occurDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="附件" align="center" prop="document">
        <template slot-scope="scope">
          <el-link type="primary" @click="reviewWord(`${baseUrl}${'/profile/upload' + scope.row.document}`)">
            {{ getFileName(scope.row.document) }}
          </el-link>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['device:record:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['device:record:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改cmc设备费用对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="设备" prop="deviceId">
          <el-select style="width: 90%;" v-model="form.deviceId" filterable placeholder="请选择" clearable disabled>
            <el-option v-for="item in alldeviceList" :key="item.deviceId" :disabled="item.status != 1" :label="item.name + '【' + (item.brand != null ? item.brand : '') + (item.series != null ? '-' + item.series + '】' : '')
      + (item.code != null ? '（设备编号：' + item.code + '）' : '') + '📍' + item.place" :value="item.deviceId">
            </el-option>
          </el-select>
          <el-button type="primary" icon="el-icon-plus" size="mini" @click="openDevice = true">选择设备</el-button>
        </el-form-item>
        <el-form-item label="负责人" prop="userId">
          <el-select v-model="form.userId" filterable clearable @change="handleQuery">
            <el-option v-for="item in $store.state.user.userList" :key="item.userId" :label="item.nickName"
              :value="item.userId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="费用类型" prop="expenseType">
          <el-select v-model="form.expenseType" placeholder="请选择" clearable @change="expenseTypePath">
            <el-option label="保险费" value="0"></el-option>
            <el-option label="维修/保养费" value="1"></el-option>
            <el-option label="检定费" value="3"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="费用金额" prop="expense">
          <el-input-number :controls="false" v-model="form.expense" placeholder="请输入费用金额" style="width:150px" />
          <el-tag>元</el-tag>
        </el-form-item>
        <el-form-item label="发生日期" prop="occurDate">
          <el-date-picker clearable v-model="form.occurDate" type="date" value-format="yyyy-MM-dd"
            placeholder="请选择发生日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="附件" prop="document">
          <div v-if="form.document">
            <el-link type="primary" @click="reviewWord(`${baseUrl}${'/profile/upload' + form.document}`)">
              {{ getFileName(form.document) }}
            </el-link>
            <el-link class="ml20" type="warning" :href="`${baseUrl}${'/profile/upload' + form.document}`"
              :underline="false" target="_blank">
              <span class="el-icon-download">下载文件</span>
            </el-link>
          </div>
          <FileUpload :limit="1" :filePathName="expenseName"
            :fileType="['doc', 'docx', 'xls', 'xlsx', 'pdf', 'rar', 'zip']" @input="getExpensePath"></FileUpload>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog title="选择设备" :visible.sync="openDevice" width="70%" append-to-body>
      <device-list @chooseList="confirmDevice" :multiple="false"></device-list>
    </el-dialog>
  </div>
</template>

<script>
import { listDeviceExpense, getDeviceExpense, delDeviceExpense, addDeviceExpense, updateDeviceExpense } from "@/api/oa/device/deviceExpense";
import { listDevice } from "@/api/oa/device/device"
import ChooseDevice from '../../flowable/form/budget/components/chooseDevice.vue';
import DeviceList from '../supply/deviceList.vue';

export default {
  name: "DeviceExpense",
  components: {
    ChooseDevice,
    DeviceList
  },
  data() {
    return {
      baseUrl: process.env.VUE_APP_BASE_API,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // cmc设备费用表格数据
      deviceExpenseList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
        deviceId: null,
        userId: null,
        expenseType: null,
        expense: null,
        occurDate: null,
        document: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        expenseType: [
          { required: true, message: '请选择费用类型', trigger: 'change' }
        ]
      },
      deviceList: [],
      alldeviceList: [],
      openDevice: false,
      expenseName: ''
    };
  },
  created() {
    this.getList();
    this.getAllDevice();
  },
  methods: {
    /** 查询cmc设备费用列表 */
    getList() {
      this.loading = true;
      this.queryParams.carId = 0;
      listDeviceExpense(this.queryParams).then(response => {
        this.deviceExpenseList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getAllDevice() {
      listDevice({
        pageNum: 1,
        pageSize: 99999,
      }).then(res => {
        this.alldeviceList = res.rows;
      })
    },
    remoteMethod(val) {
      listDevice({
        pageNum: 1,
        pageSize: 50,
        brand: val
      }).then(res => {
        this.deviceList = res.rows;
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        deviceExpenseId: null,
        deviceId: null,
        userId: null,
        expenseType: null,
        expense: null,
        occurDate: null,
        remark: null,
        document: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.deviceExpenseId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "新增设备维保记录";
    },
    handleView(row) {

    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const deviceExpenseId = row.deviceExpenseId || this.ids
      getDeviceExpense(deviceExpenseId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改设备维保记录";
        this.expenseTypePath(this.form.expenseType);
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.deviceExpenseId != null) {
            updateDeviceExpense(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDeviceExpense(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const deviceExpenseIds = row.deviceExpenseId || this.ids;
      this.$modal.confirm('是否确认删除cmc设备费用编号为"' + deviceExpenseIds + '"的数据项？').then(function () {
        return delDeviceExpense(deviceExpenseIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('oa/deviceExpense/export', {
        ...this.queryParams
      }, `deviceExpense_${new Date().getTime()}.xlsx`)
    },
    expenseTypeText(row) {
      if (row == '0') {
        return '保险费'
      }
      if (row == '1') {
        return '维修/保养费'
      }
      if (row == '3') {
        return '检定费'
      }
    },
    expenseTypeStyle(row) {
      if (row == '0') {
        return 'primary'
      }
      if (row == '1') {
        return 'warning'
      }
      if (row == '3') {
        return 'success'
      }
    },
    expenseTypePath(val) {
      if (val == '0') {
        this.expenseName = '设备/保险费'
      }
      if (val == '1') {
        this.expenseName = '设备/维修保养费'
      }
      if (val == '3') {
        this.expenseName = '设备/检定费'
      }
    },
    confirmDevice(val) {
      this.form.deviceId = val.deviceId
      this.openDevice = false;
    },
    //费用附件路径
    getExpensePath(val) {
      if (!this.form.expenseType) {
        this.$modal.msgError("请先选择费用类型");
        return;
      }
      let arr = val.split('/upload')
      this.form.document = arr[1]
      if (val == "") {
        this.form.document = ""
      }
    },
  }
};
</script>
<style lang="scss" scoped>
@import "@/assets/styles/element-reset.scss";
</style>